/***************************************************************************************

***************************************************************************************/

#ifndef _AEC_H_
#define _AEC_H_

#include "global.h"

MotionInfoContexts* create_contexts_MotionInfo(void);
TextureInfoContexts* create_contexts_TextureInfo(void);
void init_contexts_MotionInfo(struct img_par *img, MotionInfoContexts *enco_ctx);
void init_contexts_TextureInfo(struct img_par *img, TextureInfoContexts *enco_ctx);
void delete_contexts_MotionInfo(MotionInfoContexts *enco_ctx);
void delete_contexts_TextureInfo(TextureInfoContexts *enco_ctx);

void AEC_new_slice();

void readMB_typeInfo_AEC(SyntaxElement *se, struct inp_par *inp, struct img_par *img, DecodingEnvironmentPtr dep_dp);
void readB8_typeInfo_AEC(SyntaxElement *se, struct inp_par *inp, struct img_par *img, DecodingEnvironmentPtr dep_dp);
void readMVD_AEC(SyntaxElement *se, struct inp_par *inp, struct img_par *img, DecodingEnvironmentPtr dep_dp);
void readCBP_AEC(SyntaxElement *se, struct inp_par *inp, struct img_par *img, DecodingEnvironmentPtr dep_dp);
void readRunLevel_AEC(SyntaxElement *se, struct inp_par *inp, struct img_par *img,  DecodingEnvironmentPtr dep_dp);
void readRunLevel_AEC_Ref(SyntaxElement *se, struct inp_par *inp, struct img_par *img,  DecodingEnvironmentPtr dep_dp);
unsigned int biari_decode_symbolW(DecodingEnvironmentPtr dep, BiContextTypePtr bi_ct1, BiContextTypePtr bi_ct2 );
void readDquant_AEC(SyntaxElement *se,struct inp_par *inp,struct img_par *img,DecodingEnvironmentPtr dep_dp);

int  readSyntaxElement_AEC(SyntaxElement *se, struct img_par *img, struct inp_par *inp, DataPartition *this_dataPart);

void CheckAvailabilityOfNeighborsAEC();
unsigned int biari_decode_symbol_new(DecodingEnvironmentPtr dep, BiContextTypePtr bi_ct );
void readRunLenghtFromBuffer_AEC( SyntaxElement *se,
struct inp_par *inp,
struct img_par *img,
  DecodingEnvironmentPtr dep_dp);


#endif  // _AEC_H_

