/***************************************************************************************

***************************************************************************************/



/*
*************************************************************************************
* File name: mbuffer.h
* Function: Frame buffer functions
*
*************************************************************************************
*/

#ifndef _BUFFER_H_
#define _BUFFER_H_

#include "global.h"

/*! one single frame */
typedef struct 
{
  int  used;
  int  valid;           
  byte **mref;
  byte ***mcef;
} Frame;

/* the whole frame buffer structure containing frames */
typedef struct
{
  Frame **picbuf;
} FrameBuffer;
FrameBuffer *fb;

byte ***mref;                                   //<! these are pointer arrays to the actual structures
byte ****mcef;                                  //<! these are pointer arrays to the actual structures

byte **mref_fref_frm[2]; //mref_fref[ref_index][height(height/2)][width] ref_index=0 for B frame, 
byte **mref_bref_frm[2]; //mref_bref[ref_index][height(height/2)][width] ref_index=0 for B frame,
byte **mcef_fref_frm[2][2];//mcef_fref[ref_index][uv][height/2][width] ref_index=0 for B frame, 
byte **mcef_bref_frm[2][2];//mcef_bref[ref_index][uv][height/2][width] ref_index=0 for B frame

byte **mref_fref[2]; //mref_fref[ref_index][height(height/2)][width] ref_index=0 for B frame,
byte **mref_bref[2]; //mref_bref[ref_index][height(height/2)][width] ref_index=0 for B frame, 
byte **mcef_fref[2][2];//mcef_fref[ref_index][uv][height/2][width] ref_index=0 for B frame, 
byte **mcef_bref[2][2];//mcef_bref[ref_index][uv][height/2][width] ref_index=0 for B frame,
#endif

