/***************************************************************************************

***************************************************************************************/


/*
*************************************************************************************
* File name: 
* Function: 
*
*************************************************************************************
*/
#ifndef _DEFINES_H_
#define _DEFINES_H_

#define TRACE          0 //!< 0:Trace off 1:Trace on

#define FastME

// mv prediction
#define MVPRED_xy_MIN   0
#define MVPRED_L        1
#define MVPRED_U        2
#define MVPRED_UR       3
// mv prediction end

//new transform
#define DCT_TRANS

//for ivc profile
#define IVC_PROFILE
#define BASELINE_PROFILE_ID    0x20
#define P_SUB_TYPE
#ifdef P_SUB_TYPE
#define HPGOPSIZE 4
#define L1_IMG          1   //sub P frame
#define L2_IMG          2   //sub P frame
#define L3_IMG          3   //sub P frame
#define P_SUB_OPT
#endif
#define RDO_Q
#define B_DIRECT_REMOVE     

// end



#define TOTRUN_NUM    15

#define LUMA_8x8        2
#define CHROMA_DC       6
#define CHROMA_AC       7
#define NUM_BLOCK_TYPES 8

#define MIN(a,b)  (((a)<(b)) ? (a) : (b))  
#define MAX(a,b)  (((a)<(b)) ? (b) : (a))  
#define clamp(a,b,c) ( (a)<(b) ? (b) : ((a)>(c)?(c):(a)) )    //!< clamp a to the range of [b;c]


// ---------------------------------------------------------------------------------
#define _LUMA_COEFF_COST_       4 //!< threshold for luma coeffs


#define IMG_PAD_SIZE    4   //!< Number of pixels padded around the reference frame (>=4)

#define absm(A) ((A)<(0) ? (-(A)):(A)) //!< abs macro, faster than procedure
#define MAX_VALUE       999999   //!< used for start value for some variables

#define Clip1(a)            ((a)>255?255:((a)<0?0:(a)))
#define Clip3(min,max,val) (((val)<(min))?(min):(((val)>(max))?(max):(val)))

// ---------------------------------------------------------------------------------

#define B8_SIZE         8       // block size of block transformed by IVC
// ---------------------------------------------------------------------------------

#define P8x8    8
#define I8MB    9
#define IBLOCK  11
#define MAXMODE 13

#define  LAMBDA_ACCURACY_BITS         16
#define  LAMBDA_FACTOR(lambda)        ((int)((double)(1<<LAMBDA_ACCURACY_BITS)*lambda+0.5))
#define  WEIGHTED_COST(factor,bits)   (((factor)*(bits))>>LAMBDA_ACCURACY_BITS)
#define  MV_COST(f,s,cx,cy,px,py)     (WEIGHTED_COST(f,mvbits[((cx)<<(s))-px]+mvbits[((cy)<<(s))-py]))
#define  REF_COST(f,ref)              (WEIGHTED_COST(f,refbits[(ref)]))

#define  BWD_IDX(ref)                 (((ref)<2)? 1-(ref): (ref))

#define IS_INTRA(MB)    ((MB)->mb_type==I8MB)
#define IS_INTER(MB)    ((MB)->mb_type!=I8MB)
#define IS_INTERMV(MB)  ((MB)->mb_type!=I8MB && (MB)->mb_type!=0)
#define IS_DIRECT(MB)   ((MB)->mb_type==0     && (img ->   type==B_IMG))
#define IS_COPY(MB)     ((MB)->mb_type==0     && img ->   type==INTER_IMG)
#define IS_P8x8(MB)     ((MB)->mb_type==P8x8)

#define MIN_QP          0
#define MAX_QP          63
#define SHIFT_QP        11

// Picture types
#define INTRA_IMG       0   //!< I frame
#define INTER_IMG       1   //!< P frame
#define B_IMG           2   //!< B frame

// Direct Mode types
#define BLOCK_SIZE      4
#define MB_BLOCK_SIZE   16
#define BLOCK_MULTIPLE      (MB_BLOCK_SIZE/(2*BLOCK_SIZE))

//!< 8x8 luma intra prediction modes
#define DC_PRED               2


// 8x8 chroma intra prediction modes
#define DC_PRED_8       0

#define EOS             1         //!< End Of Sequence


#define MAX_SYMBOLS_PER_MB  1200  //!< Maximum number of different syntax elements for one MB
                                  // CAVLC needs more symbols per MB
#define MAXPICTURETYPESEQUENCELEN 100   /*!< Maximum size of the string that defines the picture
                                             types to be coded, e.g. "IBBPBBPBB" */


#define MEMFIX

#define ERROR_BIT


#define ERROR_REF_NUM

#endif

